#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <time.h>
#include <sys/neutrino.h>

#include "/proj4/api.h"
#include "/proj4/api/memtype.h"

int main (int argc, char *argv[]) 
{
	uint64_t start, stop;
	mem_data_t msg;
	int fd;
	int nodeid = 1;
	int i;
	short cnt = 32760;
	
	fd = open ("/dev/sfins", O_RDONLY);
	if (fd == -1) {
		perror ("can't open sfins device ");
		exit (EXIT_FAILURE);
	}	


	while (1) {

		ClockTime (CLOCK_REALTIME, NULL, &start);
		
		memset (&msg, 0, sizeof (msg));
		msg.node_id = 0;
		msg.addr = 0;
		msg.code = WR_WRD;
		msg.n_elem = 2;
		printf ("%04hX\n", cnt); 	
		msg.data [0] = cnt ++;
		printf ("%04hX\n", cnt); 	
		msg.data [1] = cnt ++;

		devctl (fd, DCMD_WRITE_MEM, &msg, sizeof (msg), NULL);
		if (msg.ret_code < 0) {
			fprintf (stderr, "Error while devctl write\n");
			exit (EXIT_FAILURE);
		}	

		
		memset (&msg, 0, sizeof (msg));
		msg.node_id = 0;
		msg.addr = 0;
		msg.code = WR_WRD;
		msg.n_elem = 2;

		devctl (fd, DCMD_READ_MEM, &msg, sizeof (msg), NULL);
		if (msg.ret_code < 0) {
			fprintf (stderr, "Error while devctl read\n");
			exit (EXIT_FAILURE);
		}	
		for (i= 0; i< msg.n_elem; i++) {
			printf ("addr %d = %d\n", msg.addr + i, msg.data [i]);
		}

		ClockTime (CLOCK_REALTIME, NULL, &stop);
		printf ("time elapsed %8.3f ms\n", (double)(stop - start)/ 1000000.0);
	}
	
	close (fd);
	return EXIT_SUCCESS;
}